\NeedsTeXFormat{LaTeX2e}[1995/12/01]
\ProvidesClass{thesetb}[1999/06/01\space
           LaTeX2e document class^^J
===========(thesetb\space JM.Rouet, ENST-Bretagne)============^^J
This class has been inspired from thloria, D. Roegel, LORIA]

%% Possibilits Offertes actuellement :
%% 
%%%%  Page de titre automatique (option rennes1 ou brest)
%% --> avec personnalisation de la page possible (chgt des champs par
%% dfaut
%%
%%%%  3 Styles d'en-tte de chapitres 
%% --> option ChapStyle0 (normal book), ChapStyle1 (Chiffres en
%%     Grand), ChapStyle2 (numerotation ordinale des chapitres)
%%
%%%%  Quelques Defines de symboles mathmatiques (ensemble Z, R, N...)
%%
%%%%  commandes pour produire les Chapitres spciaux :
%% --> \Resume \Abstract \Introduction \Conclusion \Remerciements
%%
%%%%  Environnement Dedicace
%% --> \begin{ThesisDedication}
%%     \end{ThesisDedication}
%%
%%%%  Renommage de labels en style French (Figure., ...)
%%
%%%%  Option draft
%% --> Double interligne c'est tout !
%%
%%%% le package Caption2.sty est utilis pour avoir des captions plus
%%   jolis ! Neanmoins ce package n'est pas toujours disponible dans
%%   les distributions latex standard... a recuper sur le site
% ftp://ftp.loria.fr/pub/ctan/macros/latex/contrib/supported/caption/caption2.dtx 

%%%% Choses a rajouter.... 
%%
%% --> Une documentation extensive ou un exemple dtaill
%% --> ????

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Definition des Options
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%% Option draft
\newif\if@draft
\@draftfalse 
\DeclareOption{draft}{%
  \@drafttrue
  }

%% Styles de chapitre
\newif\if@style@chapLargeNum
\@style@chapLargeNumfalse 
\DeclareOption{ChapStyle1}{%
  \@style@chapLargeNumtrue
  \@style@chapOrdinalfalse
  \@style@chapDefaultfalse
  }
\newif\if@style@chapOrdinal
\@style@chapOrdinalfalse
\DeclareOption{ChapStyle2}{%
  \@style@chapOrdinaltrue
  \@style@chapLargeNumfalse
  \@style@chapDefaultfalse
  }
\newif\if@style@chapDefault
\@style@chapDefaulttrue % Style par dfaut
\DeclareOption{ChapStyle0}{%
  \@style@chapOrdinalfalse
  \@style@chapLargeNumfalse
  \@style@chapDefaulttrue
  }

%% Styles de couverture
\newif\if@style@rennes
\@style@rennesfalse
\DeclareOption{rennes1}{%
  \@style@rennestrue
  }
\newif\if@style@brest
\@style@brestfalse
\DeclareOption{brest}{%
  \if@style@rennes
  \ClassWarning*{thesetb}
  {Options \string`brest\string' is ignored\MessageBreak
    when \string`rennes\string' is present.}
  \else
  \@style@bresttrue
  \fi
  }

\DeclareOption*{\PassOptionsToClass{\CurrentOption}{book}}
\ProcessOptions
\LoadClass[a4paper]{book}[1995/01/31]

\RequirePackage[latin1]{inputenc}


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%  Page de Titre                                 %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%% Commandes disponibles

%% Commande               Valeur par dfaut (rennes1)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% \NumeroOrdre           --- (Champ Obligatoire)
%% \ThesisKind            Thse
%% \ThesisDate            --- (Champ Obligatoire)
%% \ThesisPresented       prsente
%% \ThesisPresentedBy     par
%% \ThesisPresentedThe    soutenue le `date' devant la commission
%%                        d'examen~: 
%% \ThesisBefore          devant l'Universit de Rennes~I   
%% \ThesisInOrderToGet    pour obtenir \\\vfill le grade de~:~
%% \ThesisDiploma         Docteur de l'Universit de Rennes~I
%% \ThesisMention         --- (Champ Obligatoire qui peu etre vide) 
%% \ThesisAuthor          --- (Champ Obligatoire)
%% \ThesisTitle           --- (Champ Obligatoire)
%% 
%% \ClearAffil  : Reinitialise les champs d'affiliation
%% \ClearJury   : Reinitialise les champs du Jury
%% \NewAffilCategory : Ajoute une catgorie d'affiliation
%%    Les catgories prexistantes sont : Equipe(s)Accueil, Ecole(s)Doctorale(s)
%%    la mise a jour se fait comme suit : 
%%        \EquipeAccueil = {Departement Toto,\\ENST-Bretagne}
%% \NewJuryCategory : Meme chose avec les catgories prdfinies : 
%%    President, Rapporteurs, Examinateurs, Invites
%%
%% \MakeThesisTitlePage  !!! LA commande pour creer la page de titre
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\if@style@rennes
  \typeout{Mise en page selon le style de these de l'ecole doctorale de  rennes 1}
\else
  \if@style@brest
    \typeout{Mise en page selon le style de these de l'ecole doctorale de    l'UBO}
  \else
    \ClassWarning{thesetb}{style de these non dfini}
  \fi
\fi

\newcommand{\@NumeroOrdre}{\fbox{{\tt\char`\\NumeroOrdre}}}
\newcommand\NumeroOrdre[1]{\renewcommand{\@NumeroOrdre}{#1}}
\newcommand{\@ThesisNumeroOrdre}{{\UseEntryFont{ThesisNumeroOrdre}%
    \noindent
    \underline{$\mbox{N}^o$ d'ordre~: \@NumeroOrdre}}}

                                % Titre (THESE)
\newcommand{\@ThesisKind}{{\UseEntryFont{ThesisKind}Thse}}
\newcommand\ThesisKind[1]%
{\renewcommand{\@ThesisKind}{{\UseEntryFont{ThesisKind}#1}}}

                                % Date de la soutenance
\newcommand{\@ThesisDate}{\fbox{{\tt\char`\\ThesisDate}}}
\newcommand\ThesisDate[1]{\renewcommand{\@ThesisDate}{#1}}

                                % prsente
\newcommand{\@ThesisPresented}{{\UseEntryFont{ThesisPresented}prsente
    \if@style@brest  \fi}}
\newcommand\ThesisPresented[1]%
{\renewcommand{\@ThesisPresented}{{\UseEntryFont{ThesisPresented}#1}}}

                                % par
\newcommand{\@ThesisPresentedBy}{{\UseEntryFont{ThesisPresentedBy}par}}
\newcommand\ThesisPresentedBy[1]%
{\renewcommand{\@ThesisPresentedBy}{{\UseEntryFont{ThesisPresentedBy}#1}}}

                                % soutenue le ...
\newcommand{\@ThesisPresentedThe}{{\UseEntryFont{ThesisPresentedThe}%
    soutenue le \@ThesisDate{} devant la commission d'examen~:}}
\newcommand\ThesisPresentedThe[1]%
{\renewcommand{\@ThesisPresentedThe}{{\UseEntryFont{ThesisPresentedThe}#1}}}

                                % DEVANT L'UNIVERSITE DE RENNES 1
\newcommand{\@ThesisBefore}%
{{\UseEntryFont{ThesisBefore}%
    \if@style@rennes devant \fi l'Universit de \if@style@rennes
    Rennes~I \else Bretagne Occidentale \fi}}
\newcommand\ThesisBefore[1]%
{\renewcommand{\@ThesisBefore}{{\UseEntryFont{ThesisBefore}#1}}}

                                % pour obtenir le grade de :
\newcommand{\@ThesisInOrderToGet}%
{{\UseEntryFont{ThesisInOrderToGet}pour obtenir \if@style@brest le
    titre de\\\vfill \else \\\vfill le grade de~:~\fi}}
\newcommand\ThesisInOrderToGet[1]%
{\renewcommand{\@ThesisInOrderToGet}{{\UseEntryFont{ThesisInOrderToGet}#1}}}

                                % DOCTEUR DE L'UNIVERSITE DE RENNES 1
\newcommand{\@ThesisDiploma}%
{{\UseEntryFont{ThesisDiploma}%
    Docteur de l'Universit de \if@style@rennes Rennes~I \else
    Bretagne Occidentale \fi}}
\newcommand\ThesisDiploma[1]%
{\renewcommand{\@ThesisDiploma}{{\UseEntryFont{ThesisDiploma}#1}}}

                                % Mention
\newcommand{\@ThesisMention}{{\UseEntryFont{ThesisMention}Mention~:
    \fbox{\'ecrire \tt\char`\\ThesisMention\{ la mention \}}}}
\newcommand\ThesisMention[1]%
{\renewcommand{\@ThesisMention}{
    \def\@tmppar{#1}
    \if\@tmppar\@empty
    \else
    {\UseEntryFont{ThesisMention}Mention~: {\it #1}}
    \fi }}

                                % Composition du Jury
\newcommand{\@CompositionDuJury}{\underline{\UseEntryFont{ThesisCompositionJury}
Composition du Jury~:}\\[5mm]}
\newcommand\CompositionDuJury[1]%
{\renewcommand{\@CompositionDuJury}{
    \def\@tmppar{#1}
    \if\@tmppar\@empty
    \else
    {\UseEntryFont{ThesisCompositionJury}#1}
    \fi }}
                                % Auteur
\newcommand{\@ThesisAuthor}%
{{\UseEntryFont{ThesisAuthor}%
    \fbox{\'ecrire \tt\char`\\ThesisAuthor\{ l'auteur \}}}}
\newcommand\ThesisAuthor[1]%
{\renewcommand{\@ThesisAuthor}{{\UseEntryFont{ThesisAuthor}#1}}}


                                % Titre de la thse
\newcommand{\@ThesisTitle}%
{{\UseEntryFont{ThesisTitle}\fbox{\tt\char`\\ThesisTitle}\par}}
\newcommand\ThesisTitle[1]%
{\renewcommand{\@ThesisTitle}{\hrulefill\\{\UseEntryFont{ThesisTitle}#1\par}\hrulefill\\}}

\newcommand\SetEntryFont[2]{\expandafter\def\csname @#1font\endcsname{#2}}
\newcommand\SetTBFont[7]{\expandafter\def\csname @#1font\endcsname
  {\TBusefont{#2}{#3}{#4}{#5}{#6}{#7}}}

\newcommand\UseEntryFont[1]{\csname @#1font\endcsname}
\newcommand{\TBusefont}[6]{\fontsize{#5}{#6}\usefont{#1}{#2}{#3}{#4}}
\newcommand{\TitlePageFontFamily}{cmr}
\newcommand{\TitlePageFontEncoding}{T1}
\SetTBFont{ThesisNumeroOrdre}%
{\TitlePageFontEncoding}{\TitlePageFontFamily}{m}{n}{12}{14}%
\SetTBFont{ThesisTitle}%
{\TitlePageFontEncoding}{\TitlePageFontFamily}{bx}{n}{20.74}{25}%
\SetTBFont{ThesisKind}%
{\TitlePageFontEncoding}{\TitlePageFontFamily}{bx}{sc}{20.74}{25}%
\SetTBFont{ThesisPresented}%
{\TitlePageFontEncoding}{\TitlePageFontFamily}{m}{n}{14}{15}%
\SetTBFont{ThesisBefore}%
{\TitlePageFontEncoding}{\TitlePageFontFamily}{bx}{sc}{20.74}{25}%
\SetTBFont{ThesisPresentedThe}%
{\TitlePageFontEncoding}{\TitlePageFontFamily}{m}{n}{14}{15}%
\SetTBFont{ThesisInOrderToGet}%
{\TitlePageFontEncoding}{\TitlePageFontFamily}{m}{n}{14}{15}%
\SetTBFont{ThesisDiploma}%
{\TitlePageFontEncoding}{\TitlePageFontFamily}{bx}{sc}{17.28}{20}
\SetTBFont{ThesisMention}%
{\TitlePageFontEncoding}{\TitlePageFontFamily}{m}{n}{14}{15}%
\SetTBFont{ThesisPresentedBy}%
{\TitlePageFontEncoding}{\TitlePageFontFamily}{m}{n}{14}{15}%
\SetTBFont{ThesisAuthor}%
{\TitlePageFontEncoding}{\TitlePageFontFamily}{bx}{n}{17.28}{20}
\SetTBFont{ThesisJury}%
{\TitlePageFontEncoding}{\TitlePageFontFamily}{m}{n}{14}{15}%
\SetTBFont{ThesisAffil}%
{\TitlePageFontEncoding}{\TitlePageFontFamily}{m}{n}{12}{14}%
\SetTBFont{ThesisAffilSmall}%
{\TitlePageFontEncoding}{\TitlePageFontFamily}{m}{n}{10}{12}%
\SetTBFont{ThesisCompositionJury}%
{\TitlePageFontEncoding}{\TitlePageFontFamily}{m}{n}{14}{15}%

\newif\if@affiliation
\@affiliationfalse
\newtoks\@affil@tokI
\newtoks\@affil@tokII
\newcommand\@tokc@t[3]{%
  \edef\@tokconc@t{\the#1\the#2}%
  #3=\expandafter{\@tokconc@t}%
  }
\newtoks\@thesis@affil
\newcommand{\NewAffilCategory}[3]{%
  \expandafter\newtoks\csname#1\endcsname
  \csname#1\endcsname={}%
  \expandafter\def\csname#1@title\endcsname{{#2}{#3}}%
  \@affil@tokI=\expandafter{\csname#1\endcsname}%
  \@tokc@t\@thesis@affil\@affil@tokI\@thesis@affil
  \@affil@tokI=\expandafter{\csname#1@title\endcsname}%
  \@tokc@t\@thesis@affil\@affil@tokI\@thesis@affil
  }
\newcommand{\ClearAffil}{\@thesis@affil={}}
\ClearAffil
\NewAffilCategory{EquipeAccueil}{\'Equipe d'accueil~:}{\'Equipe d'accueil~:}
\NewAffilCategory{EquipesAccueil}{\'Equipes d'accueil~:}{\'Equipes d'accueil~:}
\NewAffilCategory{EcoleDoctorale}{\'Ecole doctorale~:}{\'Ecole doctorale~:}
\NewAffilCategory{EcolesDoctorales}{\'Ecoles doctorales~:}{\'Ecoles doctorales~:}
\def\@selectiaffil#1{\expandafter\@@selectiaffil#1}
\def\@@selectiaffil#1#2{{#1}}
\def\@selectiiaffil#1{\expandafter\@@selectiiaffil#1}
\def\@@selectiiaffil#1#2{{#2}}
\newcommand\@buildaffil[1]{%
  \@affil@tokI={\bgroup\UseEntryFont{ThesisAffil}\begin{tabular}{lll}}%
    \expandafter\@@buildaffil\the#1/%
    \@affil@tokII={\end{tabular}\egroup}%
  \@tokc@t\@affil@tokI\@affil@tokII\@affil@tokI
  \the\@affil@tokI
  }
\def\@@buildaffil#1#2#3/{%
  \def\@tmpa{#3}%
  \ifx\@tmpa\@empty
  \def\@tmpa{#1}%
  \ifx\@tmpa\@empty
  \else\@buildentryaffil#1#2%
  \fi
  \else
  \@buildentryaffil#1#2%
  \@@buildaffil#3/%
  \fi
  }
\newcommand\@buildentryaffil[2]{\expandafter\@buildtableaffil\the#1\\/#2}
\def\@buildtableaffil#1\\#2/#3{%
  \def\@tmpa{#1}%
  \ifx\@tmpa\@empty
  \else
  \@affiliationtrue %cette variable est utilise pour supprimer un
                    % \vfill lorsqu'il n'y a pas d'affiliation de 
                    % prcise
  \def\@tmpa{#2}%
  \ifx\@tmpa\@empty
  \@affil@tokII={\@selectiaffil#3&#1\\}%
  \@tokc@t\@affil@tokI\@affil@tokII\@affil@tokI
  \else
  \@affil@tokII={\@selectiiaffil#3&#1\\}%
  \@tokc@t\@affil@tokI\@affil@tokII\@affil@tokI
  \@@buildtableaffil#2/%
  \fi
  \@affil@tokII={[3mm]}%
  \@tokc@t\@affil@tokI\@affil@tokII\@affil@tokI
  \fi
  }
\def\@@buildtableaffil#1\\#2/{%
  \@affil@tokII={&#1\\}%
  \@tokc@t\@affil@tokI\@affil@tokII\@affil@tokI
  \def\@tmpa{#2}%
  \ifx\@tmpa\@empty
  \else\@@buildtableaffil#2/%
  \fi
  }



\newcommand\@ThesisAffil{
  \if@style@rennes
  \vspace{1cm}\@buildaffil\@thesis@affil
  \else
  \UseEntryFont{ThesisAffil}\fbox{utiliser \tt\char`\\ThesisAffil\{Travail ralis au sein...\}}
  \fi
}
\newcommand\ThesisAffil[1]%
{\@affiliationfalse \ClearAffil \renewcommand{\@ThesisAffil}{{\UseEntryFont{ThesisAffilSmall}#1\par}}}


\newtoks\@jury@tokI
\newtoks\@jury@tokII
\newtoks\@thesis@jury
\newcommand{\NewJuryCategory}[3]{%
  \expandafter\newtoks\csname#1\endcsname
  \csname#1\endcsname={}%
  \expandafter\def\csname#1@title\endcsname{{#2}{#3}}%
  \@jury@tokI=\expandafter{\csname#1\endcsname}%
  \@tokc@t\@thesis@jury\@jury@tokI\@thesis@jury
  \@jury@tokI=\expandafter{\csname#1@title\endcsname}%
  \@tokc@t\@thesis@jury\@jury@tokI\@thesis@jury
  }
\newcommand{\ClearJury}{\@thesis@jury={}}
\ClearJury
\NewJuryCategory{President}{\textit{Pr\'esident :}}{\textit{Pr\'esidents :}}
\NewJuryCategory{Rapporteurs}{\textit{Rapporteur :}}{\textit{Rapporteurs :}}
\NewJuryCategory{Examinateurs}{\textit{Examinateur :}}{\textit{Examinateurs :}}
\NewJuryCategory{Invites}{\textit{Invit\'e :}}{\textit{Invit\'es :}}
\def\@selecti#1{\expandafter\@@selecti#1}
\def\@@selecti#1#2{{#1}}
\def\@selectii#1{\expandafter\@@selectii#1}
\def\@@selectii#1#2{{#2}}
\newcommand\@buildjury[1]{%
  \@jury@tokI={\bgroup\UseEntryFont{ThesisJury}\begin{tabular}{lll}}%
    \expandafter\@@buildjury\the#1/%
    \@jury@tokII={\end{tabular}\egroup}%
  \@tokc@t\@jury@tokI\@jury@tokII\@jury@tokI
  \the\@jury@tokI
  }
\def\@@buildjury#1#2#3/{%
  \def\@tmpa{#3}%
  \ifx\@tmpa\@empty
  \def\@tmpa{#1}%
  \ifx\@tmpa\@empty
  \else\@buildentry#1#2%
  \fi
  \else
  \@buildentry#1#2%
  \@@buildjury#3/%
  \fi
  }
\newcommand\@buildentry[2]{\expandafter\@buildtable\the#1\\/#2}
\def\@buildtable#1\\#2/#3{%
  \def\@tmpa{#1}%
  \ifx\@tmpa\@empty
  \else
  \def\@tmpa{#2}%
  \ifx\@tmpa\@empty
  \@jury@tokII={\@selecti#3&#1\\}%
  \@tokc@t\@jury@tokI\@jury@tokII\@jury@tokI
  \else
  \@jury@tokII={\@selectii#3&#1\\}%
  \@tokc@t\@jury@tokI\@jury@tokII\@jury@tokI
  \@@buildtable#2/%
  \fi
  \@jury@tokII={[3mm]}%
  \@tokc@t\@jury@tokI\@jury@tokII\@jury@tokI
  \fi
  }
\def\@@buildtable#1\\#2/{%
  \@jury@tokII={&#1\\}%
  \@tokc@t\@jury@tokI\@jury@tokII\@jury@tokI
  \def\@tmpa{#2}%
  \ifx\@tmpa\@empty
  \else\@@buildtable#2/%
  \fi
  }
\newcommand\@ThesisJury{\@buildjury\@thesis@jury}

\newlength\@bindingshift
\setlength\@bindingshift{0pt}
\newcommand\SetBinding[1]{%
  \setlength\@bindingshift{#1}%
  \divide\@bindingshift2\relax
  }
\newlength\@htitlepageshift
\newcommand{\@cover@hook}{}
\newenvironment{changemargin}[2]{\begin{list}{}{%
\setlength{\topsep}{0pt}%
\setlength{\leftmargin}{0pt}%
\setlength{\rightmargin}{0pt}%
\setlength{\listparindent}{\parindent}%
\setlength{\itemindent}{\parindent}%
\setlength{\parsep}{0pt plus 1pt}%
\addtolength{\leftmargin}{#1}%
\addtolength{\rightmargin}{#2}%
}\item }{\end{list}}

\newcommand{\MakeThesisTitlePage}%
{%
  \newpage
  \@cover@hook
  \thispagestyle{empty}%
  \begin{changemargin}{-1.5cm}{-1cm}
    \@thesis@titlep@gebody
  \end{changemargin}
  \newpage  
  \if@twoside
  \thispagestyle{empty}
  \hbox{}
  \par\vfill
  \newpage
  \addtocounter{page}{-2}%
  \else
  \addtocounter{page}{-1}%
  \fi
  \fontencoding{OT1}\normalfont\selectfont
  }%
\newcommand\@thesis@titlep@gebody{%
 %---------------------------------------------------
  \vspace*{-2cm}
  \@ThesisNumeroOrdre
  \begin{center}
    \@ThesisKind
    \vfill
    \@ThesisPresented
    \vfill
    \@ThesisBefore
    \vfill
    \@ThesisInOrderToGet \@ThesisDiploma
    \vfill
    \@ThesisMention
    \vfill
    \@ThesisPresentedBy
    \vfill
    \@ThesisAuthor
    \vfill
  \end{center} 
  \if@style@rennes
  \begin{center}
    \@ThesisAffil
  \end{center}
  \if@affiliation
  \vfill
  \fi
  \fi
  \begin{center}
    \@ThesisTitle
%    \vspace{1cm}
    \vfill
    \@ThesisPresentedThe\\
    \vfill
    \@CompositionDuJury
    \@ThesisJury
    \if@style@brest
    \vfill
    \hrulefill\\
    \@ThesisAffil
    \fi
  \end{center}
 %---------------------------------------------------
  }

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%  Defines Divers                                %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% les ensembles mathmatiques
\RequirePackage{bbm}
\def\N{\ensuremath{\mathbbm{N}}}
\def\R{\ensuremath{\mathbbm{R}}}
\def\Z{\ensuremath{\mathbbm{Z}}}

\def\Q{\ensuremath{\mathbbm{Q}}}
\def\C{\ensuremath{\mathbbm{C}}}
\def\F{\ensuremath{\mathbbm{F}}}
\def\K{\ensuremath{\mathbbm{K}}}

% le \fixme est pratique pour marquer les endroits 
% corriger ultrieurement dans la thse (crit en gras
% on le trouve facilement sur le papier, et par ailleurs
% ou avec la commande unix :
% find . -name \*.tex -exec grep '\\fixme' {} \; -print
\def\fixme{{\bf FIXME: }}

\def\cad{\mbox{c.--d.}}
\def\cf{{cf.}}
\def\ie{{\it i.e.}}


%------ quelques commandes de formatage de pages / paragraphes ------
\newcommand{\DS}[1]{\displaystyle{#1}}
\newcommand{\bsloppy}{\begin{sloppypar}}
\newcommand{\esloppy}{\end{sloppypar}}
\newcommand{\msaut}{\vspace*{-0.1cm}}
\newcommand{\gsaut}{\vspace*{1.cm}}
\newcommand{\saut}{\vspace*{.5cm}}
\newcommand{\psaut}{\vspace*{.2cm}}
\newcommand{\ppsaut}{\vspace*{.1cm}}
\newcommand{\malinea}{\hspace*{-2cm}}
\newcommand{\alinea}{\hspace*{2cm}}
\newcommand{\palinea}{\hspace*{1cm}}
\newcommand{\ppalinea}{\hspace*{0.5cm}}
\newcommand{\psalinea}{\hspace*{0.2cm}}
\newcommand{\build}[3]{\mathrel{\mathop{\kern 0pt#1}\limits_{#2}^{#3}}}
\newcommand{\Accolade}[1]{\left\{\begin{array}{l} #1 \end{array}\right. }
\newcommand{\Entrepar}[1]{\left( \begin{array}{c}\hspace*{-0.2cm} #1
\hspace*{-0.2cm}\end{array}\right) }
\newcommand{\Entreacc}[1]{\left\{ \begin{array}{c}\hspace*{-0.2cm} #1
      \hspace*{-0.2cm}\end{array}\right\} }

%-------------- quelques "shortcuts" pratiques ...  ----------------
% \renewcommand{\cf}{{\sl cf.~}}
\newcommand{\cffig}[1]{(\cf~figure~\ref{#1})}
\newcommand{\cfequ}[1]{(\cf~quation~\eqref{#1})}
\newcommand{\cfpar}[1]{(\cf~paragraphe~\ref{#1})}
\newcommand{\etc}{{etc.}}

%--------- pour les citations ( la place de \citation) ------------
\newcommand{\citat}[2]{
\begin{tabular}{p{5.5cm}p{9cm}}
 & \og {\small  {\sl #1}} \fg\\
 &\vspace*{0.5mm} {\scriptsize #2} 
\end{tabular} } 



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%  PAGE LAYOUT                                   %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


\topmargin 0mm
\headheight 10mm
\headsep 10mm
\footskip 10mm
\columnsep 6mm
\columnseprule 0pt

\sloppy
\parindent 2.5em
\leftmargini 2em
\leftmargin\leftmargini
\leftmarginv .5em
\leftmarginvi .5em


\if@twoside
\setlength{\oddsidemargin}{0.55cm}
\setlength{\evensidemargin}{0cm} 
\else
\oddsidemargin  0.5cm  
\evensidemargin 0.5cm  
\fi

\marginparwidth 1.5cm   %   Width of marginal notes.
\textwidth      15.5cm  
\voffset        -1.0cm  % Decalage vertical vers le haut
\textheight     23.5cm


% on dtermine le nombre de flottants autoriss par page,
\setcounter{totalnumber}{6} 
\renewcommand{\floatpagefraction}{.7}
\renewcommand{\topfraction}{1.0}
\renewcommand{\bottomfraction}{1.0}
\renewcommand{\textfraction}{0.00}


\setlength{\parindent}{0.6cm} % indent au debut d'un paragraph
\setlength{\parskip}{1.5mm}   % distance entre paragraphes

% \RequirePackage{epsfig}
\if@draft
% \psfull % pour garder les images quand meme
\def\baselinestretch{1.62} %% double interligne en 11pt
\else
\def\baselinestretch{1.0}
\fi


% The `\flushbottom' declaration makes all text pages the same height,
% adding extra vertical space when necessary to fill out the page.
%    This is the standard if twocolumn mode is selected.
\flushbottom

% on commence en chiffres romains jusqu'a \mainmatter
\pagenumbering{roman} 



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%  Style french                                  %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\RequirePackage[frenchb]{babel}

\frenchspacing
\def\acknowledgmentsname{Remerciements}
\def\introductionname{Introduction}
\def\conclusionname{Conclusion}
\def\myabstractname{Abstract}
\def\resumename{Rsum}
\addto\captionsfrenchb{\def\pagename{page}}
\addto\captionsfrenchb{\def\refname{R\'ef\'erences}}
\addto\captionsfrenchb{\def\bibname{Bibliographie}}
\addto\captionsfrenchb{\def\listfigurename{Liste des figures}}
\addto\captionsfrenchb{\def\listtablename{Liste des tableaux}}
\addto\captionsfrenchb{\def\indexname{Index}}
\addto\captionsfrenchb{\def\seename{\emph{voir}}}
\addto\captionsfrenchb{\def\seealsoname{\emph{voir aussi}}}
\addto\captionsfrenchb{\def\figurename{Figure}}
\addto\captionsfrenchb{\def\tablename{Tableau}}
\addto\captionsfrenchb{\def\partname{\protect\@RPt partie}}
\addto\captionsfrenchb{\def\@RPt{{\ifcase\value{part}\or Premi\`ere\or Deuxi\`eme\or 
      Troisi\`eme\or Quatri\`eme\or Cinqui\`eme\or Sixi\`eme\or 
      Septi\`eme\or Huiti\`eme\or Neuvi\`eme\or Dixi\`eme\or 
      Onzi\`eme\or Douzi\`eme\or Treizi\`eme\or Quatorzi\`eme\or 
      Quinzi\`eme\or Seizi\`eme\or Dix-septi\`eme\or
      Dix-huiti\`eme\or Dix-neuvi\`eme\or Vingti\`eme\fi}\space\def\thepart{}}}
\addto\captionsfrenchb{\def\glossaryname{Glossaire}}
\addto\captionsfrenchb{\def\chaptername{Chapitre}}
\addto\captionsfrenchb{\def\appendixname{Annexe}}
\addto\captionsfrenchb{\def\appendixtitle{Annexe du chapitre}}
\ifx\ier\undefined\def\ier{er}\fi
\addto\captionsfrenchb{\def\today{\ifnum\day=1\relax 1\ier
    \else \number\day\fi
    \space\ifcase\month\or janvier\or f\'evrier\or mars\or 
    avril\or mai\or juin\or juillet\or ao\^ut\or septembre\or 
    octobre\or novembre\or d\'ecembre\fi \space\number\year}}

%\renewcommand\abstractname{R\'esum\'e}
\def\note#1{\footnote{---~#1}}

\def\L#1{\ensuremath{{\cal {L}}^{#1}}}
\def\Linf{\ensuremath{{\cal {L}}^{\infty}\,}}
%\def\degre{\ensuremath{{}^{\circ}}}


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% FancyHeadings
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\RequirePackage{fancyheadings}
\pagestyle{fancyplain}

%%% On dfinit les marqueurs de haut de page...
\chead{}
%%% Dans le mode oneside on affiche les references du chapitre en haut
\newlength\lheadtitle
\newlength\lpagenumber
\settowidth{\lpagenumber}{\thepage}
\addtolength{\lpagenumber}{2em}

\if@twoside
\rhead[\fancyplain{}{\hspace{\lpagenumber}\slshape \leftmark}]{\fancyplain{}{\thepage}}
\lhead[\fancyplain{}{\thepage}]{\fancyplain{}%
  {\slshape \rightmark\hspace{\lpagenumber}}}
\else
\lhead{\fancyplain{}{\leftmark\hspace{\lpagenumber}}}
\rhead{\fancyplain{}{\thepage}}
% \rhead[\fancyplain{}{\slshape \rightmark}]{\fancyplain{}{~\thepage}}
\fi

%%% ... et les marqueurs de bas de page
\cfoot{}
\rfoot{}
\lfoot{}




%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%  Chapitre                                      %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\renewcommand\cleardoublepage{%
% On desire, dans le cas du recto-verso, si la page de
% gauche n'a pas de texte, d'enlever le style 
% (le haut et le bas de la page) 
\clearpage
\if@twoside
  \ifodd\c@page
  \else
    \hbox{}\thispagestyle{empty}\newpage
  \fi
\fi 
}


\if@style@chapLargeNum
  \RequirePackage{fancyheadings}
  \RequirePackage{ifthen}
  \renewcommand\chaptername{chapitre}
  \newfont{\chapfonte}{cmr10 scaled 9000}
                                % La taille (=hauteur) de la fonte est 10pt * scaled / 1000
                                % Remarque : \magstep<n> vaut 1000*(1.2)^n
                                % Donc \magstep1 multiplie la fonte par 1.2, ie l'augmente de 20%

  \def\haut{20mm}         % Hauteur des chiffres,  ajuster avec 'scaled'
  \def\decal{1.75ex}      % Pour aligner la ligne avec le haut de CHAPITRE

  \newlength{\lgnamechap}
  \newlength{\lgnumchap}
  \newlength{\lgall}

  \def\@makechapterhead#1{%
    %\thispagestyle{empty}% pas de numro de page
    \def\myboxtwo{\mbox{\chapfonte\thechapter}}
    
    %
    % pour myboxone (style de chapitre (annexe ou these)) impossible
    % d'utiliser la macro \@chapapp !!! ne fonctionne pas dans le
    % \Large\sf\uppercase\expandafter{\@chapapp} !!!
    %
      
    \ifthenelse{\equal{\@chapapp}{\chaptername}}%
    {\def\myboxone{\Large\sf\uppercase\expandafter{\chaptername}}}%
    {\def\myboxone{\Large\sf\uppercase\expandafter{\appendixname}}}

%     \def\myboxone{\Large\sf\uppercase\expandafter{\chaptername}}\else
%     \def\myboxone{\Large\sf\uppercase\expandafter{\appendixname}}\fi
    
    \settowidth{\lgnamechap}{\myboxone}
    \settowidth{\lgnumchap}{\myboxtwo}
    \addtolength{\lgnumchap}{6mm}
    \setlength{\lgall}{\textwidth}
    \addtolength{\lgall}{-\lgnamechap}
    \addtolength{\lgall}{-\lgnumchap}
    \addtolength{\lgall}{-5pt}
    {\parindent\z@
      \parbox[t]{\lgnamechap}{\myboxone}
      \raisebox{\decal}{%
        \raisebox{-\haut}{\parbox[t]{\lgnumchap}{\hspace{2mm}\myboxtwo}}}
      \raisebox{\decal}{\parbox[t]{\lgall}{\rule{\lgall}{1mm}
          \begin{flushleft}
            \Huge\bf{#1}
          \end{flushleft}
          }}
      \par
      \nobreak
      \vskip 100\p@
      }
    }

\def\@makeschapterhead#1{%
  % \thispagestyle{empty}% pas de numro de page
  \def\myboxtwo{\mbox{\chapfonte 1}}
  \def\myboxone{\Large\sf\uppercase\expandafter{chapitre}}
  \settowidth{\lgnamechap}{\myboxone}
  \settowidth{\lgnumchap}{\myboxtwo}
  \addtolength{\lgnumchap}{6mm}
  \setlength{\lgall}{\textwidth}
  \addtolength{\lgall}{-\lgnamechap}
  \addtolength{\lgall}{-\lgnumchap}
  \addtolength{\lgall}{-5pt}
  {
    \typeout{----------> }
    \typeout{----------> \@chapapp\space #1.}
    \typeout{----------> }
    \parindent\z@
    \parbox[t]{\lgnamechap}{\hspace{\lgnamechap}}
    \raisebox{\decal}{%
      \raisebox{-\haut}{\parbox[t]{\lgnumchap}{\hspace{2mm}\hspace{\lgnumchap}}}}
    \raisebox{\decal}{\parbox[t]{\lgall}{\rule{\lgall}{1mm}          
        \begin{flushleft}
          \Huge\bf{#1}
        \end{flushleft}
        }}
    \par
    \nobreak
    \vskip 100\p@
    }
   \def\myname{#1}
   \def\mymajname{\MakeUppercase{\myname}}
   \markboth{\mymajname}{\mymajname}
%   \markboth{\MakeUppercase{#1}}{\MakeUppercase{#1}}
%   \chaptermark{#1}
  }

\fi % fin de la definition du style ChapitreLargeNum (Style1)

\if@style@chapOrdinal
%   \renewcommand{\ps@plain}{%
%     \renewcommand{\@evenhead}{}%
%     \renewcommand{\@oddhead}{}%
%     \renewcommand{\@evenfoot}{\hfill\textrm{\thepage}\hfill}%}
%     \renewcommand{\@oddfoot}{\@evenfoot}}

  \def\@Fch{{\ifcase\value{chapter}\or Premier\or Deuxi\`eme\or
      Troisi\`eme\or Quatri\`eme\or Cinqui\`eme\or Sixi\`eme\or
      Septi\`eme\or Huiti\`eme\or Neuvi\`eme\or Dixi\`eme\or Onzi\`eme\or
      Douzi\`eme\or Treizi\`eme\or Quatorzi\`eme\or Quinzi\`eme\or
      Seizi\`eme\or Dix-septi\`eme\or Dix-huiti\`eme\or Dix-neuvi\`eme\or
      Vingti\`eme\fi}\space\def\thechapter{}}


  \def\@makechapterhead#1{             % Heading for \chapter command
    \thispagestyle{empty}
                                % \vspace*{50pt}                     % Space at top of text page.
    { \parindent 0pt \raggedright 
      \ifnum \c@secnumdepth >\m@ne     % IF secnumdepth > -1 THEN
                                %\large\bf \@chapapp{} \thechapter % Print 'Chapter' and number.
      \LARGE\bf \protect\@Fch\space \chaptername
      \typeout{----------> \@chapapp\space #1.}
      \par 
      \vskip 30pt \fi                  % Space between number and title.
      
      \hspace*{5mm}
      \parbox{150mm}{
        \begin{flushleft}
          
          \Huge \bf                        % Title in parbox (left aligned)
          #1\par
          
        \end{flushleft} }
      
      \nobreak                         % TeX penalty to prevent page break.
      \vskip 120pt                      % Space between title and text.
      } 
    }
\fi % fin de la definition du style ChapitreOrdinal (ChapStyle2)

\if@style@chapDefault
\fi % fin de la definition du style ChapitreNormal (ChapStyle0)


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% caption %%% ATTENTION CE N'est PAS forcement support par toutes les
% distrib LateX 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\RequirePackage{caption2}

\captionstyle{centerlast}
\renewcommand\captionfont{\footnotesize}
\renewcommand\captionlabelfont{\bfseries\itshape}
%\setcaptionmargin{\leftmargini}
%\setlength\captionindent{\parindent}
\renewcommand\captionlabeldelim{~---}
\onelinecaptionstrue
\setcaptionwidth{12.9999cm}



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% varioref
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\RequirePackage{varioref}

\def\reftextfaceafter {\`a la page \reftextvario{ci-contre}{suivante}}
\def\reftextfacebefore{\`a la page \reftextvario{pr\'ec\'edente}{ci-contre}}
\def\reftextafter     {\`a la page suivante}
\def\reftextbefore    {\`a la page pr\'ec\'edente}
\def\reftextcurrent   {de la pr\'esente page}
\def\reftextfaraway#1{page~\pageref{#1}}

\vrefwarning


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% PARstart (comme dans le style IEEE)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\def\PARstart#1#2{\begingroup\def\par{\endgraf\endgroup\lineskiplimit=0pt}
    \setbox2=\hbox{\uppercase{#2} }\newdimen\tmpht \tmpht \ht2
    \advance\tmpht by \baselineskip\font\hhuge=cmr10 at \tmpht
    \setbox1=\hbox{{\hhuge #1}}
    \count7=\tmpht \count8=\ht1\divide\count8 by 1000 \divide\count7 by\count8
    \tmpht=.001\tmpht\multiply\tmpht by \count7\font\hhuge=cmr10 at \tmpht
    \setbox1=\hbox{{\hhuge #1}} \noindent \hangindent1.05\wd1
    \hangafter=-2 {\hskip-\hangindent \lower1\ht1\hbox{\raise1.0\ht2\copy1}%
    \kern-0\wd1}\copy2\lineskiplimit=-1000pt}

\if@draft\def\PARstart#1#2{#1#2}\fi % if draft, disable it





%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%  Remerciements, Rsum, Abstract, Intro, Conclu, Biblio %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\newcommand{\Remerciements}[1]{%
  \chapter*{#1}
  \addcontentsline{toc}{chapter}{#1}
}
\newcommand{\Introduction}[1]{%
  \chapter*{#1}
  \addcontentsline{toc}{chapter}{#1}
}
\newcommand{\Conclusion}[1]{%
  \chapter*{#1}
  \addcontentsline{toc}{chapter}{#1}
}
\newcommand{\Abstract}[1]{%
  \chapter*{#1}
  \addcontentsline{toc}{chapter}{#1}
}
\newcommand{\Resume}[1]{%
  \chapter*{#1}
  \addcontentsline{toc}{chapter}{#1}
}
\newcommand{\Notations}[1]{%
  \chapter*{#1}
  \addcontentsline{toc}{chapter}{#1}
}
\newcommand{\Abreviations}[1]{%
  \chapter*{#1}
  \addcontentsline{toc}{chapter}{#1}
}
\newcommand{\ListeFigures}[1]{%
  \cleardoublepage
  \addcontentsline{toc}{chapter}{#1}
  \listoffigures
}
\newcommand{\ListeTables}[1]{%
  \cleardoublepage
  \addcontentsline{toc}{chapter}{#1}
  \listoftables
}
\newcommand{\Bibliographie}[1]{%
  \cleardoublepage
  \addcontentsline{toc}{chapter}{\bibname}
  \bibliography{#1}
}


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%  ChapterAbstract                               %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\newcommand{\@chapterabstract@hook}{}
\newenvironment{ChapterAbstract}%
{%
  \@chapterabstract@hook
  \vspace*{\stretch{1}} 
  }
{% 
  \vspace*{\stretch{2}}
  \newpage
  }


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%  Page de Signatures                            %%
%%  paramtres : Nom de l'universit,             %%
%%               Prsident de l'universit        %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\newcommand{\PageSignatures}[2]{%
  % exemple (RennesI) : 
  % \PageSignatures{l'Universit de Rennes~I}{Patrick NAVATTE}
  \cleardoublepage
  \thispagestyle{empty}
  {
    \Large
    \vspace*{-2cm}
    \hspace{-2.5cm}
    \begin{minipage}[t]{0.5\textwidth}
      \begin{center}
        VU~:\\[2cm]
        Le Directeur de Th\`ese      
      \end{center} 
    \end{minipage}%
    \hspace{2cm}
    \begin{minipage}[t]{0.5\textwidth}
      \begin{center}
        VU~:\\[2cm]
        \mbox{Le Responsable de l'\'Ecole Doctorale}
      \end{center}
    \end{minipage}


    \vspace*{\stretch{2}}
    \begin{center}
      \begin{minipage}[t]{0.8\textwidth}    
        VU pour autorisation de soutenance\\[0.5cm]
        Rennes, le\\[0.5cm]
        Le Prsident de #1
      \end{minipage}
      
      \vspace*{\stretch{1}}

      #2

      \vspace*{\stretch{3}}

      \begin{minipage}[t]{0.8\textwidth}    
        VU aprs soutenance pour autorisation de publication~:\\[0.5cm]
        Le Prsident de Jury,
      \end{minipage}
    \end{center}  
    \vspace*{\stretch{2}}
    }
  }
  
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%  ThesisDedication                              %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\newcommand{\@dedication@hook}{}
\newenvironment{ThesisDedication}{%
  \cleardoublepage
  \@dedication@hook
  \@mkboth{}{}
  \thispagestyle{plain}
  \vglue0pt plus.5fil
  \fontfamily{\sfdefault}\fontseries{m}\fontshape{sl}\selectfont
  \begin{flushright}
    }%
  {%
  \end{flushright}
  \vglue0pt plus1fil\cleardoublepage
  }


\endinput
